// ROTATOR 1
#include <LiquidCrystal.h>
#include <EEPROM.h>
#include <Wire.h>
// V = EEPROM.read(30)
// EEPROM.write(30, V)

const int rs = 11, en = 9, d4 = 7, d5 = 5, d6 = 3, d7 = 2;
LiquidCrystal lcd(rs, en, d4, d5, d6, d7);
int T1=0;
int T2=0;
int T3=1;
int T4=1;
int T5=1;
int T6=1;
int T7=1;

int F=0;//CITAC TIMERU
int x1=0;
float T=0;

int R= EEPROM.read(10);//RYCHLOST - EEPROM ADRESA 10H - (10 , 20 ,......2500)/ms/
int U= EEPROM.read(20)*5;//UHEL 5-10-..........360
int t1= EEPROM.read(30)*10;//TIMER1
int K= EEPROM.read(40);//POCET KROKU
int C= EEPROM.read(50);//POCET CYKLU
int t6= EEPROM.read(60)*10;//TIMER 


const int in1 = 14;// čísla pinů pro digitální výstupy
const int in2 = 15;
const int in3 = 16;
const int in4 = 17;

int v=2; //max SILA !!!!
//int R = 1;// RYCHLOST proměnná pro nastavení rychlosti,// se zvětšujícím se číslem se rychlost zmenšuje
//int U = 180;//UHEL

int i1=0;
int i2=0;
int i3=0;

//=====================================

void setup() {
  lcd.begin(16, 2);
  lcd.print("ROTATOR 360st.  ");lcd.setCursor(0, 1);lcd.print("READY");
   
pinMode(10, INPUT_PULLUP);//MENU
pinMode(8, INPUT_PULLUP);//P+
pinMode(6, INPUT_PULLUP);//P-
pinMode(4, INPUT_PULLUP);//RUN
pinMode(0, INPUT_PULLUP);//TEST
pinMode(14, OUTPUT);//PC0
pinMode(15, OUTPUT);//PC1
pinMode(16, OUTPUT);//PC2
pinMode(17, OUTPUT);//PC3
pinMode(18, OUTPUT);//PC4
pinMode(19, OUTPUT);//PC5
pinMode(12, INPUT_PULLUP);//PB3
pinMode(13, INPUT_PULLUP);//PB4
//pinMode(12, OUTPUT);//PB3
//pinMode(13, OUTPUT);//PB4

digitalWrite(14, LOW);
digitalWrite(15, LOW);
digitalWrite(16, LOW);
digitalWrite(17, LOW);
digitalWrite(18, LOW);
digitalWrite(19, LOW);


}
//================================================================================================
void loop() {
T1 = digitalRead(10); T2 = digitalRead(8); T3 = digitalRead(6); T4 = digitalRead(4); T5 = digitalRead(1); 
T6 = digitalRead(12); T7 = digitalRead(13); 
if (T1==0){ F=F+1;lcd.setCursor(10, 1);lcd.print("      ");  }
if (F==11){ F=1;   lcd.setCursor(10, 1);lcd.print("      ");  }
//=====================================RYCHLOST===============================================
if(F==1){lcd.setCursor(0, 1);lcd.print("RYCHLOST       ");
         lcd.setCursor(10, 1);lcd.print(R);    lcd.setCursor(0, 0);lcd.print("ROTATOR 360st  "); 
if (T2==0){ R=R+1; lcd.setCursor(10, 1);lcd.print(R); EEPROM.write(10,R) ;  } 
if (T3==0){ R=R-1; lcd.setCursor(10, 1);
lcd.setCursor(0, 1);lcd.print("RYCHLOST       "); lcd.setCursor(10, 1);lcd.print(R); EEPROM.write(10,R) ;  } 

if (R>=11){ R=10; lcd.setCursor(0, 1);lcd.print("RYCHLOST       ");
lcd.setCursor(10, 1);lcd.print(R);  EEPROM.write(10,R) ;    }

if (R<=1){ R=1; lcd.setCursor(0, 1);lcd.print("RYCHLOST       ");
lcd.setCursor(10, 1);lcd.print(R);  EEPROM.write(10,R) ;    }
         } 
//====================================UHEL================================================
if(F==2){lcd.setCursor(0, 1);         lcd.print("UHEL          ");
         lcd.setCursor(10, 1);lcd.print(U);     lcd.setCursor(0, 0);lcd.print("ROTATOR 360st  "); 
if (T2==0){ U=U+5; lcd.setCursor(10, 1);lcd.print(U); EEPROM.write(20, U/5) ;   } 
if (T3==0){ U=U-5;  lcd.setCursor(11, 1);lcd.print("          ");
lcd.setCursor(10, 1);lcd.print(U); EEPROM.write(20, U/5) ;   }
if (U<=1){ U=5; lcd.setCursor(10, 1);lcd.print(U);    EEPROM.write(20, U/5) ;   }
if (U>=361){ U=360; lcd.setCursor(10, 1);lcd.print(U);EEPROM.write(20, U/5) ;  }  
         } 
//=====================================TIMER1=================================================
if(F==3){lcd.setCursor(0, 1);lcd.print("TIMER1(ms)");
         lcd.setCursor(10, 1);lcd.print(t1);     lcd.setCursor(0, 0);lcd.print("ROTATOR 360st  "); 
if (T2==0){ t1=t1+100; lcd.setCursor(10, 1);lcd.print(t1); EEPROM.write(30, t1/10) ;   } 
if (T3==0){ t1=t1-100;  lcd.setCursor(11, 1);lcd.print("          ");
lcd.setCursor(10, 1);lcd.print(t1);  EEPROM.write(30, t1/10) ;  }
if (t1<=1){ t1=100; lcd.setCursor(10, 1);lcd.print(t1);    EEPROM.write(30, t1/10) ;   }
if (t1>=2501){ t1=2500; lcd.setCursor(10, 1);lcd.print(t1);EEPROM.write(30, t1/10) ;  }
       } 
//======================================KROKY===============================================       
if(F==4){lcd.setCursor(0, 1);lcd.print("POCET KROKU     ");
         lcd.setCursor(12, 1);lcd.print(K);     lcd.setCursor(0, 0);lcd.print("ROTATOR 360st  "); 
if (T2==0){ K=K+1; lcd.setCursor(12, 1);lcd.print(K); EEPROM.write(40, K) ;  } 
if (T3==0){ K=K-1;  lcd.setCursor(12, 1);lcd.print("          ");
lcd.setCursor(12, 1);lcd.print(K);EEPROM.write(40, K) ;   } 
if (K<=1){ K=1; lcd.setCursor(12, 1);lcd.print(K);  EEPROM.write(40, K) ;    }
if (K>=251){ K=250; lcd.setCursor(12, 1);lcd.print(K);EEPROM.write(40, K) ; }   
         }
//========================================CYKLY===============================================
if(F==5){lcd.setCursor(0, 1);lcd.print("POCET CYKLU    ");
         lcd.setCursor(12, 1);lcd.print(C);     lcd.setCursor(0, 0);lcd.print("ROTATOR 360st  "); 
if (T2==0){ C=C+1; lcd.setCursor(12, 1);lcd.print(C); EEPROM.write(50, C) ;  } 
if (T3==0){ C=C-1;  lcd.setCursor(12, 1);lcd.print("          ");
lcd.setCursor(12, 1);lcd.print(C);EEPROM.write(50, C) ;   } 
if (C<=1){ C=1; lcd.setCursor(12, 1);lcd.print(C);  EEPROM.write(50, C) ;    }
if (C>=251){ C=250; lcd.setCursor(12, 1);lcd.print(C);EEPROM.write(50, C) ; }   
         } 
//========================================TIMER6==============================================
if(F==6){lcd.setCursor(0, 1);lcd.print("TIMER6(ms)");
         lcd.setCursor(10, 1);lcd.print(t6);     lcd.setCursor(0, 0);lcd.print("ROTATOR 360st  "); 
if (T2==0){ t6=t6+100; lcd.setCursor(10, 1);lcd.print(t6); EEPROM.write(60, t6/10) ;  } 
if (T3==0){ t6=t6-100;  lcd.setCursor(11, 1);lcd.print("          ");
lcd.setCursor(10, 1);lcd.print(t6);EEPROM.write(60, t6/10) ;   } 
if (t6<=1){ t6=100; lcd.setCursor(10, 1);lcd.print(t6);  EEPROM.write(60, t6/10) ;    }
if (t6>=2501){ t6=2500; lcd.setCursor(10, 1);lcd.print(t6);EEPROM.write(60, t6/10) ; }
         } 
//=======================================================================================                      
if(F==7){lcd.setCursor(0, 1);lcd.print("START VLEVO    ");
         lcd.setCursor(10, 0);lcd.print(t6);     lcd.setCursor(0, 0);lcd.print("ROTATOR 360st  ");
if(T4==0){

for(int i3=0;i3<C;i3++){
for(int i2=0;i2<K;i2++){
for(int i1=0;i1<(U*64/45);i1++){rotacePoSmeru();};delay(t1);};delay(t6);}
  
}
        }      
//==================================================================================
if(F==8){lcd.setCursor(0, 1);lcd.print("START VPRAVO");
         lcd.setCursor(10, 0);lcd.print(t6);     lcd.setCursor(0, 0);lcd.print("ROTATOR 360st  ");

if(T4==0){

for(int i3=0;i3<C;i3++){
for(int i2=0;i2<K;i2++){
for(int i1=0;i1<(U*64/45);i1++){rotaceProtiSmeru();};delay(t1);};delay(t6);}
  
}

        }      
//==================================================================================
if(F==9){lcd.setCursor(0, 1);lcd.print("VPRAVO VLEVO");
         lcd.setCursor(10, 0);lcd.print(t6);     lcd.setCursor(0, 0);lcd.print("ROTATOR 360st  ");

if(T4==0){
n100:
for(int i3=0;i3<C;i3++){
for(int i2=0;i2<K;i2++){
for(int i1=0;i1<(U*64/45);i1++){rotaceProtiSmeru();};delay(t1);};delay(t6);}

for(int i3=0;i3<C;i3++){
for(int i2=0;i2<K;i2++){
for(int i1=0;i1<(U*64/45);i1++){rotacePoSmeru();};delay(t1);};delay(t6);};goto n100;
  
}




        }      
//==================================================================================
if(F==10){lcd.setCursor(0, 1);lcd.print("REZERVA     ");
         lcd.setCursor(10, 0);lcd.print(t6);     lcd.setCursor(0, 0);lcd.print("ROTATOR 360st  ");

        }      
//==================================================================================
//  if(T4==0){
//  for(int i=0;i<(U*64/45);i++){rotacePoSmeru();};//// plná rotace o 360 stupňů = 512 volání
//  delay(1000);digitalWrite(in4,LOW);digitalWrite(in3,LOW);digitalWrite(in2,LOW);digitalWrite(in1,LOW);
  
//  for(int i=0;i<(U*64/45);i++){ rotaceProtiSmeru();  }
// delay(1000);digitalWrite(in4,LOW);digitalWrite(in3,LOW);digitalWrite(in2,LOW);digitalWrite(in1,LOW);//
//  delay(333); }
//==================================================================================

//==================================================================================

//=================================================================================
  
//==================================================================================
 
//=================================================================================

//==============================RESET MEMORY========================================================
if(T5==0){lcd.setCursor(0, 1);lcd.print("MEMORY DELETE   ");delay(555);F=1; 
EEPROM.write(10, 10) ; delay(20);//RYCHLOST
EEPROM.write(20,9) ;delay(20);//UHEL
EEPROM.write(30,50) ;delay(20);//TIMER1 t1
EEPROM.write(40, 8) ;delay(20);//POCET KROKU K
EEPROM.write(50, 2) ;delay(20);//POCET CYKLU C
EEPROM.write(60, 100) ;delay(20);//TIMER2 t6

R= EEPROM.read(10);//RYCHLOST  - EEPROM ADRESA 10H - (1-10)
U= EEPROM.read(20)*5;//UHEL- EEPROM ADRESA 20H - (1-72)
t1= EEPROM.read(30)*10;//TIMER 1 - EEPROM ADRESA 30H - (10 , 20 ,......2500)/ms/

K= EEPROM.read(40);//LROKY - EEPROM ADRESA 40H - 
C= EEPROM.read(50);//CYKLY - EEPROM ADRESA 50H - 
t6= EEPROM.read(60)*10;//TIMER 2 - EEPROM ADRESA 60H - (10 , 20 ,......2500)/ms/

}
 delay(555);
}
//============================= zde následují funkce pro volání jednotlivých "PODPROGRAMŮ"
void rotacePoSmeru() {krok1();delay(v); krok2();delay(v);krok3();delay(v);krok4();delay(v);
                      krok5();delay(v);krok6();delay(v);krok7();delay(v);krok8();delay(v);};
                        
void rotaceProtiSmeru() {krok8();delay(v);krok7();delay(v);krok6();delay(v);krok5();delay(v);
                      krok4();delay(v);krok3();delay(v);krok2();delay(v);krok1();delay(v);};
  
// pro správné spínání motoru a následnou // pauzu, kterou určujeme rychlost otáčení
void krok1(){digitalWrite(in1, HIGH);digitalWrite(in2,LOW); digitalWrite(in3,LOW); digitalWrite(in4,LOW);delay(11-R);}
void krok2(){digitalWrite(in1, HIGH);digitalWrite(in2,HIGH);digitalWrite(in3,LOW); digitalWrite(in4,LOW);delay(11-R);}
void krok3(){digitalWrite(in1, LOW);digitalWrite(in2,HIGH); digitalWrite(in3,LOW); digitalWrite(in4,LOW);delay(11-R);}
void krok4(){digitalWrite(in1, LOW);digitalWrite(in2,HIGH); digitalWrite(in3,HIGH);digitalWrite(in4,LOW);delay(11-R);}
void krok5(){digitalWrite(in1, LOW); digitalWrite(in2,LOW); digitalWrite(in3,HIGH);digitalWrite(in4,LOW);delay(11-R);}
void krok6(){digitalWrite(in1, LOW);digitalWrite(in2,LOW); digitalWrite(in3,HIGH);digitalWrite(in4,HIGH);delay(11-R);}
void krok7(){digitalWrite(in1, LOW);digitalWrite(in2,LOW); digitalWrite(in3,LOW); digitalWrite(in4,HIGH);delay(11-R);}
void krok8(){digitalWrite(in1, HIGH);digitalWrite(in2,LOW);digitalWrite(in3,LOW); digitalWrite(in4,HIGH);delay(11-R);}
